﻿using System;
using System.Runtime.InteropServices;

namespace m4lz
{
	/// <summary>
    /// mgc4lz.dll Ver4.1600a
    /// (C) m.magic & K Maruyama. All rights reserved.
    /// </summary>
    class mlz
	{
		//
		//// common
		//
		public struct POINT 
		{	
			public int x;
			public int y;
			public POINT(int x1, int y1) 
			{
				x = x1;
				y = y1;
			}
		} 
		
		public const int TRUE	= 1;
		public const int FALSE	= 0;
		public const int NULL	= 0;
		public const int YES	= TRUE;
		public const int NO		= FALSE;

		public const int SUCCESS = 0; 
		public const int FAILURE = -1; 

		//
		//// mlzInitialize
		//
		public struct INI_PARAMETERS 
		{	
			public int timerElapse;		// カーソル位置の取得間隔
			public uint functions;
		}

		/// 引数
		public const int INI_TIMER_ELAPSE_COUNT		= 9;
		public const int INI_TIMER_ELAPSE_0			= 3;
		public const int INI_TIMER_ELAPSE_1			= 4;
		public const int INI_TIMER_ELAPSE_2			= 6;
		public const int INI_TIMER_ELAPSE_3			= 8;
		public const int INI_TIMER_ELAPSE_4			= 11;
		public const int INI_TIMER_ELAPSE_5			= 16;
		public const int INI_TIMER_ELAPSE_6			= 22;
		public const int INI_TIMER_ELAPSE_7			= 32;
		public const int INI_TIMER_ELAPSE_8			= 44;
		public const int INI_TIMER_ELAPSE_DEFAULT	= INI_TIMER_ELAPSE_4;
		public const int INI_TIMER_ELAPSE_MAX		= 64;
		public const int INI_TIMER_ELAPSE_MIN		= 1;

		public const uint INI_FNC_COMMANDS		= 0x000000ff;
		public const uint INI_FNC_CMD_MODE_0	= 0x00000000;
		public const uint INI_FNC_CMD_MODE_1	= 0x00000001;
		public const uint INI_FNC_CMD_MODE_2	= 0x00000002;
		public const uint INI_FNC_CMD_MODE_3	= 0x00000003;

		public const uint INI_FNC_OPTIONS		= 0xffffff00;
		public const uint INI_FNC_OPT_0TH		= 0x00000100;	// ０次方程式判定
		public const uint INI_FNC_OPT_CIRCLE_A	= 0x00008000;	// 円の始動位置を判定する
		public const uint INI_FNC_OPT_REDRAW	= 0x08000000;	// サンプリング点描画
		public const uint INI_FNC_OPT_DEBUG		= 0x80000000;

		public const uint INI_FNC_DEFAULT		= INI_FNC_CMD_MODE_0;
		public const uint INI_FNC_STANDARD		= INI_FNC_CMD_MODE_0 | INI_FNC_OPT_REDRAW;
		
		//
        //// mlzDifferentiate
        //
        public delegate double Formula1( double Xi, IntPtr parameters );

        public struct DIF_PARAMETERS 
        {	
	        public double 	x;				// x における値を求める
	        public int	 	z;				// 微分の点数
	        public double 	h;				// x の増加量
			public Formula1 formulaLZ;	// 計算するためのコールバック関数
	        public IntPtr 	parameters;		// 任意のポインタ
        }

        /// 引数
        public const int DIF_Z_2  = 2;
        public const int DIF_Z_3  = 3;
        public const int DIF_Z_5  = 5;
        public const int DIF_Z_7  = 7;
        public const int DIF_Z_9  = 9;
        public const int DIF_Z_11 = 11;

        //
        //// mlzStart
        //
        public struct STR_PARAMETERS 
        {
        	public int bottom;	// 再描画領域
	        public int left;
	        public int right;
	        public int top;
	        public int erase; // 背景を消去するかどうか
        } 

        //
        //// mlzStop
        //

        /// 戻り値
        public const int STP_ERR_UNDER_EXECUTION    = 500;	    // 処理中
        public const int STP_ERR_KILLED_TIMER		= -500;	    // タイマー不全
        public const int STP_ERR_BUFFER_OVERFLOW	= -501;	    // サンプリング用バッファ不足
        public const int STP_ERR_TIME_OUT			= -502;	    // 時間切れ
        public const int STP_ERR_FEW_SAMPLINGS		= -503;	    // サンプリング数不足
        public const int STP_ERR_CHANGEING_POSITION	= -504;	    // 変極点位置が問題
        public const int STP_ERR_POSITION			= -505;	    // 始点終点変化点の位置が問題
        public const int STP_ERR_DISTANCE			= -580;	    // サンプリング点と最適化方程式の値の距離が大きい
        public const int STP_ERR_CANNOT_ANALYZE		= -1001;	// 解析不能

        
        //
        //// mlzGetResult
        //

        // nReturn
        public const int GRT_RTN_UNDER_EXECUTION	= STP_ERR_UNDER_EXECUTION;		// 処理中
        public const int GRT_RTN_KILLED_TIMER		= STP_ERR_KILLED_TIMER;		    // タイマー不全
        public const int GRT_RTN_BUFFER_OVERFLOW	= STP_ERR_BUFFER_OVERFLOW;		// サンプリング用バッファ不足
        public const int GRT_RTN_TIME_OUT			= STP_ERR_TIME_OUT;			    // 時間切れ
        public const int GRT_RTN_FEW_SAMPLINGS		= STP_ERR_FEW_SAMPLINGS;		// サンプリング数不足
        public const int GRT_RTN_CHANGEING_POSITION	= STP_ERR_CHANGEING_POSITION;	// 変極点位置が問題
        public const int GRT_RTN_POSITION			= STP_ERR_POSITION;			    // 始点終点変化点の位置が問題
        public const int GRT_RTN_DISTANCE			= STP_ERR_DISTANCE;			    // サンプリング点と最適化方程式の値の距離が大きい
        public const int GRT_RTN_CANNOT_ANALYZE		= STP_ERR_CANNOT_ANALYZE;		// 解析不能

        // nType
		public const uint GRT_TYPE_EQUATION	= 0x000000ff; 
		public const uint GRT_TYPE_0TH		= 0x00000000;	
		public const uint GRT_TYPE_1TH		= 0x00000001;	
		public const uint GRT_TYPE_2TH		= 0x00000002;	
		public const uint GRT_TYPE_3TH		= 0x00000003;	
		public const uint GRT_TYPE_CIRCLE	= 0x00000080;	

		public const uint GRT_TYPE_DIVISION		= 0x0000f000;
		public const uint GRT_TYPE_DIVISION_1	= 0x00001000;
		public const uint GRT_TYPE_DIVISION_2	= 0x00002000;
		public const uint GRT_TYPE_DIVISION_3	= 0x00003000;
			
        public const uint GRT_TYPE_1A   = 0x00000001;	
        public const uint GRT_TYPE_1B	= 0x00000101;	
        public const uint GRT_TYPE_1C	= 0x00000201;	
        public const uint GRT_TYPE_1D	= 0x00000301;	

        public const uint GRT_TYPE_2A	= 0x00000002;	
        public const uint GRT_TYPE_2B	= 0x00000102;	
        public const uint GRT_TYPE_2C	= 0x00000202;	
        public const uint GRT_TYPE_2D	= 0x00000302;	
        public const uint GRT_TYPE_2E	= 0x00000402;	
        public const uint GRT_TYPE_2F	= 0x00000502;	
        public const uint GRT_TYPE_2G	= 0x00000602;	
        public const uint GRT_TYPE_2H	= 0x00000702;	

        public const uint GRT_TYPE_3A	= 0x00000003;	
        public const uint GRT_TYPE_3B	= 0x00000103;	
        public const uint GRT_TYPE_3C	= 0x00000203;	
        public const uint GRT_TYPE_3D	= 0x00000303;	
        public const uint GRT_TYPE_3E	= 0x00000403;	
        public const uint GRT_TYPE_3F	= 0x00000503;	
        public const uint GRT_TYPE_3G	= 0x00000603;	
        public const uint GRT_TYPE_3H	= 0x00000703;	

		public const uint GRT_TYPE_CIRCLE_R		= 0x00000080;			// 右回転
		public const uint GRT_TYPE_CIRCLE_R0	= GRT_TYPE_CIRCLE_R;	// 右回転
		public const uint GRT_TYPE_CIRCLE_RU	= 0x00001080;			// 右回転、始点上
		public const uint GRT_TYPE_CIRCLE_RB	= 0x00002080;			// 右回転、始点下
		public const uint GRT_TYPE_CIRCLE_L		= 0x00000480;			// 左回転
		public const uint GRT_TYPE_CIRCLE_L0	= GRT_TYPE_CIRCLE_L;	// 左回転
		public const uint GRT_TYPE_CIRCLE_LU	= 0x00001480;			// 左回転、始点上
		public const uint GRT_TYPE_CIRCLE_LB	= 0x00002480;			// 左回転、始点

        public const uint GRT_TYPE_OTHER	= 0x000000ff;	
        public const uint GRT_TYPE_ERROR	= 0xffffffff;	

        public struct GRT_RESULT 
        {	
	        public int	    resultNo;		// 実行回数
	        public int	    result;			// 実行結果
	        public uint     type;			// カーソル軌跡の種別
	        public int	    changingCount;	// 変化点数
	        public int	    samplingCount;	// カーソル座標の標本数
			public int		rotated;		// 座標を回転させたかどうか
			[MarshalAs(UnmanagedType.ByValArray, SizeConst=8)]
            public double[]	coefficient;	// 係数
            public void initialize() 
            {
                coefficient = new double [8];
                resultNo = result = 0;
                type = 0;
                changingCount = samplingCount = rotated = 0;
            }
        }
        
        //
        //// mlzGetSamplingPosition
        //
        public struct GSP_PARAMETERS
        {
            public int	resultNo;           // 実行回数
            public int	count;              // 現在の標本数
			public int	changingPosition;   // 標本が変化点かどうか
            public POINT samplingPosition; // 標本座標
			public void initialize() 
			{
				resultNo = count = changingPosition = 0;
				samplingPosition.x = samplingPosition.y = 0;
			}
        }
 
        [DllImport("mgc4lz.dll")]
        public static extern int mlzInitialize(ref INI_PARAMETERS parameters);
        [DllImport("mgc4lz.dll")]
        public static extern uint mlzStart(IntPtr handle, ref STR_PARAMETERS parameters);
		[DllImport("mgc4lz.dll")]
		public static extern uint mlzStart(IntPtr handle, IntPtr parameters);
        [DllImport("mgc4lz.dll")]
        public static extern int mlzStop(IntPtr handle);
        [DllImport("mgc4lz.dll")]
        public static extern void mlzGetResult(ref GRT_RESULT result);
		[DllImport("mgc4lz.dll")]
        public static extern void mlzGetSamplingPosition(int n, ref GSP_PARAMETERS parameters);
        [DllImport("mgc4lz.dll")]
	    public static extern double	mlzDifferentiate(ref DIF_PARAMETERS parameters);
        [DllImport("mgc4lz.dll", CharSet=CharSet.Unicode)]
        public static extern int mlzGetFileVersion(	string file,
                                                    ref uint major, 
        											ref uint minor,
        											ref uint revision, 
        											ref uint bild		);
   
	}
    
}