///
//// mgc4lz.dll  Header Ver4.1600a
//
///  (C) m.magic & K Maruyama. All rights reserved.
////
#pragma once

//
//// common
//
#define MLZ_POINT	POINT
#define MLZ_TRUE	TRUE
#define MLZ_FALSE	FALSE
#define MLZ_NULL	NULL
#define	MLZ_YES		TRUE
#define	MLZ_NO		FALSE

#define MLZ_SUCCESS	0
#define MLZ_FAILURE	-1

//
//// mlzInitialize
//
typedef struct 
{	
	int	 nTimerElapse;		// J[\ʒu̎擾Ԋu
	UINT nFunction;
} MLZ_INI_PARAMETERS, *LPMLZ_INI_PARAMETERS;

/// 
#define MLZ_INI_TIMER_ELAPSE_COUNT		9
#define MLZ_INI_TIMER_ELAPSE_0			3
#define MLZ_INI_TIMER_ELAPSE_1			4
#define MLZ_INI_TIMER_ELAPSE_2			6
#define MLZ_INI_TIMER_ELAPSE_3			8
#define MLZ_INI_TIMER_ELAPSE_4			11
#define MLZ_INI_TIMER_ELAPSE_5			16 
#define MLZ_INI_TIMER_ELAPSE_6			22
#define MLZ_INI_TIMER_ELAPSE_7			32 
#define MLZ_INI_TIMER_ELAPSE_8			44
#define MLZ_INI_TIMER_ELAPSE_DEFAULT	MLZ_INI_TIMER_ELAPSE_4
#define MLZ_INI_TIMER_ELAPSE_MAX		64
#define MLZ_INI_TIMER_ELAPSE_MIN		1

#define MLZ_INI_FNC_COMMANDS		0x000000ff
#define MLZ_INI_FNC_CMD_MODE_0		0x00000000
#define MLZ_INI_FNC_CMD_MODE_1		0x00000001
#define MLZ_INI_FNC_CMD_MODE_2		0x00000002
#define MLZ_INI_FNC_CMD_MODE_3		0x00000003

#define MLZ_INI_FNC_OPTIONS			0xffffff00
#define MLZ_INI_FNC_OPT_0TH			0x00000100	// O
#define MLZ_INI_FNC_OPT_CIRCLE_A	0x00008000	// ~̎nʒu𔻒肷
#define MLZ_INI_FNC_OPT_REDRAW		0x08000000	// TvO_`
#define MLZ_INI_FNC_OPT_DEBUG		0x80000000

#define MLZ_INI_FNC_DEFAULT			MLZ_INI_FNC_CMD_MODE_0
#define MLZ_INI_FNC_STANDARD		MLZ_INI_FNC_CMD_MODE_0 | MLZ_INI_FNC_OPT_REDRAW

//
//// mlzDifferentiate
//
typedef double CALLBACK Formula1(double nXi, LPVOID lpParameters);

typedef struct 
{	
	double		nX;				// nX ɂl߂
	long		nZ;				// ̓_
	double		nH;				// nX ̑
	Formula1*	lpFormulaLZ;	// vZ邽߂̃R[obN֐
	LPVOID		lpParameters;	// Cӂ̃|C^
} MLZ_DIF_PARAMETERS, *LPMLZ_DIF_PARAMETERS;

/// 
#define MLZ_DIF_Z_2		2
#define MLZ_DIF_Z_3		3
#define MLZ_DIF_Z_5		5
#define MLZ_DIF_Z_7		7
#define MLZ_DIF_Z_9		9
#define MLZ_DIF_Z_11	11

//
//// mlzStart
//
typedef struct 
{	
	long	nBottom;	// ĕ`̈ 
	long	nLeft;
	long	nRight;
	long	nTop;
	BOOL	nErase;		// wi邩ǂ
} MLZ_STR_PARAMETERS, *LPMLZ_STR_PARAMETERS;

//
//// mlzStop
//

/// ߂l
#define MLZ_STP_ERR_UNDER_EXECUTION			 500	// 
#define MLZ_STP_ERR_KILLED_TIMER			-500	// ^C}[sS
#define MLZ_STP_ERR_BUFFER_OVERFLOW			-501	// TvOpobt@s
#define MLZ_STP_ERR_TIME_OUT				-502	// Ԑ؂
#define MLZ_STP_ERR_FEW_SAMPLINGS			-503	// TvOs
#define MLZ_STP_ERR_CHANGEING_POSITION		-504	// ϋɓ_ʒu
#define MLZ_STP_ERR_POSITION				-505	// n_I_ω_̈ʒu
#define MLZ_STP_ERR_DISTANCE				-580	// TvO_ƍœK̒lƂ̌덷傫
#define MLZ_STP_ERR_CANNOT_ANALYZE			-1001	// ͕s\

//
//// mlzGetResult
//

// nReturn
#define MLZ_GRT_RTN_UNDER_EXECUTION		MLZ_STP_ERR_UNDER_EXECUTION		// 
#define MLZ_GRT_RTN_KILLED_TIMER		MLZ_STP_ERR_KILLED_TIMER		// ^C}[sS
#define MLZ_GRT_RTN_BUFFER_OVERFLOW		MLZ_STP_ERR_BUFFER_OVERFLOW		// TvOpobt@s
#define MLZ_GRT_RTN_TIME_OUT			MLZ_STP_ERR_TIME_OUT			// Ԑ؂
#define MLZ_GRT_RTN_FEW_SAMPLINGS		MLZ_STP_ERR_FEW_SAMPLINGS		// TvOs
#define MLZ_GRT_RTN_CHANGEING_POSITION	MLZ_STP_ERR_CHANGEING_POSITION	// ϋɓ_ʒu
#define MLZ_GRT_RTN_POSITION			MLZ_STP_ERR_POSITION			// n_I_ω_̈ʒu
#define MLZ_GRT_RTN_DISTANCE			MLZ_STP_ERR_DISTANCE			// TvO_ƍœK̒lƂ̌덷傫
#define MLZ_GRT_RTN_CANNOT_ANALYZE		MLZ_STP_ERR_CANNOT_ANALYZE		// ͕s\

// nType
#define MLZ_GRT_TYPE_EQUATION	0x000000ff 
#define MLZ_GRT_TYPE_0TH		0x00000000	
#define MLZ_GRT_TYPE_1TH		0x00000001	
#define MLZ_GRT_TYPE_2TH		0x00000002	
#define MLZ_GRT_TYPE_3TH		0x00000003	
#define MLZ_GRT_TYPE_CIRCLE		0x00000080	

#define MLZ_GRT_TYPE_DIVISION	0x0000f000
#define MLZ_GRT_TYPE_DIVISION_1	0x00001000
#define MLZ_GRT_TYPE_DIVISION_2	0x00002000
#define MLZ_GRT_TYPE_DIVISION_3	0x00003000

#define MLZ_GRT_TYPE_0A			0x00000000	
#define MLZ_GRT_TYPE_0B			0x00000100	
#define MLZ_GRT_TYPE_0C			0x00000200	
#define MLZ_GRT_TYPE_0D			0x00000300	
#define MLZ_GRT_TYPE_1A			0x00000001	
#define MLZ_GRT_TYPE_1B			0x00000101	
#define MLZ_GRT_TYPE_1C			0x00000201	
#define MLZ_GRT_TYPE_1D			0x00000301	
#define MLZ_GRT_TYPE_2A			0x00000002	
#define MLZ_GRT_TYPE_2B			0x00000102	
#define MLZ_GRT_TYPE_2C			0x00000202	
#define MLZ_GRT_TYPE_2D			0x00000302	
#define MLZ_GRT_TYPE_2E			0x00000402	
#define MLZ_GRT_TYPE_2F			0x00000502	
#define MLZ_GRT_TYPE_2G			0x00000602	
#define MLZ_GRT_TYPE_2H			0x00000702	
#define MLZ_GRT_TYPE_3A			0x00000003	
#define MLZ_GRT_TYPE_3B			0x00000103	
#define MLZ_GRT_TYPE_3C			0x00000203	
#define MLZ_GRT_TYPE_3D			0x00000303	
#define MLZ_GRT_TYPE_3E			0x00000403	
#define MLZ_GRT_TYPE_3F			0x00000503	
#define MLZ_GRT_TYPE_3G			0x00000603	
#define MLZ_GRT_TYPE_3H			0x00000703	
#define MLZ_GRT_TYPE_CIRCLE_R	0x00000080	// E]	
#define MLZ_GRT_TYPE_CIRCLE_R_T	0x00001080	// E]An_
#define MLZ_GRT_TYPE_CIRCLE_R_B	0x00002080	// E]An_ 
#define MLZ_GRT_TYPE_CIRCLE_L	0x00000480	// ]
#define MLZ_GRT_TYPE_CIRCLE_L_T	0x00001480	// ]An_
#define MLZ_GRT_TYPE_CIRCLE_L_B	0x00002480	// ]An_

#define MLZ_GRT_TYPE_OTHER		0x000000ff	
#define MLZ_GRT_TYPE_ERROR		0xffffffff	

typedef struct
{	
	int		nResultNo;			// s
	int		nReturn;			// s
	int 	nType;				// J[\OՂ̎
	int		nChangingCount;		// ω_
	int		nSamplingCount;		// J[\W̕W{
	int		nRotated;			// W]ǂ
	double	nCoefficient[8];	// W
} MLZ_GRT_RESULT, *LPMLZ_GRT_RESULT;

//
//// mlzGetSamplingPosition
//
typedef struct
{	
	int		nResultNo;			// s
	int		nCount;				// ݂̕W{
	int		nChangingPosition;	// W{ω_ǂ
	POINT	ptSamplingPosition;	// W{W
} MLZ_GSP_PARAMETERS, *LPMLZ_GSP_PARAMETERS;
